<?php
require_once 'class/c_login.php';
require_once 'include/bd_pdo.php';

if (!isset($_SESSION['user'])) {
    header('Location: index.php');
    exit;
} else
    $user = unserialize($_SESSION['user']);
$user->access();
if ($user->acceso == null) {
    header('Location: main.php?error=1');
} else {
    $user->print_to_log('Profesores');
}
$fac = $user->facultad['facultad_id'] ?? -1; //obtiene la facultad del usuario, si no tiene faculad = -1
if ($user->admin) { //si es admin su facultad es null (todas las facultades)
    $fac = null;
}
?>
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Profesores</title>
    <?php
    include 'import/html_css_files.php';
    ?>
</head>

<body>
    <?php
    include "import/html_header.php";
    html_header(
        "PROFESORES",
        "Gestión de Checador "
    );
    $user->access();
    $max_count = 30;

    if (isset($_POST["desc"])) {
        $desc = $_POST["desc"];
        $filter_desc = htmlspecialchars($desc, ENT_QUOTES, 'UTF-8');

    } else {
        $desc = null;
    }
    if (isset($_POST["clave"])) {
        $clave = $_POST["clave"];
        $filter_clave = htmlspecialchars($clave, ENT_QUOTES, 'UTF-8');
    } else {
        $clave = null;
    }
    if (isset($_POST["mclave"])) {
        $clave = $_POST["mclave"];
        $filter_clave = htmlspecialchars($clave, ENT_QUOTES, 'UTF-8');
    }
    if (isset($_POST["nombre"])) {
        $desc = $_POST["nombre"];
        $filter_desc = htmlspecialchars($desc, ENT_QUOTES, 'UTF-8');
    }
    if (isset($_POST["facultad"])) {
        if ($_POST["facultad"] != "") {
            $fac = $_POST["facultad"];
            $filter_fac = htmlspecialchars($fac, ENT_QUOTES, 'UTF-8');
        }
    }
    $fs_profesores = $db->query(
        "SELECT DISTINCT PROFESOR.*, horario_view.facultad as facultad_nombre, horario_view.facultad_id FROM profesor 
        JOIN horario_profesor USING (profesor_id)
        JOIN horario_view USING (horario_id)
        WHERE 
        profesor_nombre ILIKE COALESCE(:nombre, profesor_nombre) AND profesor_clave ILIKE COALESCE(:clave, profesor_clave)
        AND facultad_id = COALESCE(:facultad, facultad_id)
        LIMIT :maxc",
        array(
            ":nombre" => "%$desc%",
            ":clave" => "%$clave%",
            ":facultad" => $fac,
            ":maxc" => $max_count
        )
    );
    $fs_facultades = $db->get('facultad');
    ?>
    <main class="content marco">
        <!-- Filtro -->
        <div class="row">
            <div class="col-12">
                <form action="profesores.php" method="post">
                    <div class="form-box">
                        <div class="form-group row">
                            <label for="filter_desc" class="col-4 col-form-label">Nombre</label>
                            <div class="col-8 col-sm-4">
                                <input id="filter_desc" name="desc" type="text" class="form-control" <?php if (isset($filter_desc)) {
                                    echo 'value="' . $filter_desc . '"';
                                } ?>>
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="filter_clave" class="col-4 col-form-label">Clave</label>
                            <div class="col-8 col-sm-4">
                                <input id="filter_clave" name="clave" type="text" class="form-control" <?php if (isset($filter_clave)) {
                                    echo 'value="' . $filter_clave . '"';
                                } ?>>
                            </div>
                        </div>
                        <?php if ($user->admin) { ?>
                            <div class="form-group row">
                                <label for="filter_facultad" class="col-4 col-form-label">Facultad</label>
                                <div class="col-8 col-sm-4">
                                    <div class="datalist datalist-select mb-1 w-100">
                                        <div class="datalist-input">Mostrar todas</div>
                                        <span class="ing-buscar icono"></span>
                                        <ul style="display:none">
                                            <li data-id="" class="pl-4">Mostrar todas</li>
                                            <?php foreach ($fs_facultades as $facultad) { ?>
                                                <li data-id="<?= $facultad['facultad_id']; ?>" class="pl-4 <?php if (isset($filter_fac) && $facultad["facultad_id"] == $filter_fac) {
                                                       echo 'selected';
                                                   } ?>">
                                                    <?= $facultad['facultad_nombre']; ?></li>
                                            <?php } ?>
                                        </ul>
                                        <input type="hidden" id="filter_facultad" name="facultad" value="">
                                    </div>
                                </div>
                            </div>
                        <?php } ?>
                    </div>
                    <div class="form-group row">
                        <div class="col-12 text-center">
                            <button type="submit" class="btn btn-outline-primary">
                                <span class="ing-buscar ing-fw"></span>
                                Filtrar
                            </button>
                            <button type="button" class="btn btn-outline-danger btn-reset">
                                <span class="ing-borrar ing-fw"></span>
                                Limpiar
                            </button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
        <div id="message"></div>
        <!-- Tabla -->
        <div class="row">
            <div class="col-12 table-responsive">
                <p>Se muestran los primeros <strong>
                        <?= $max_count; ?>
                    </strong> resultados. Utiliza los filtros para encontrar al profesor que buscas.</p>
                <table class="table table-sm table-striped table-white">
                    <thead class="thead-dark">
                        <tr>
                            <th>Clave</th>
                            <th>Nombre</th>
                            <?php if ($user->admin) { ?>
                                <th>Facultad</th>
                            <?php } ?>
                            <?php if ($user->acceso == 'w') { ?>
                                <th>Acciones</th>
                            <?php } ?>
                        </tr>
                    </thead>
                    <tbody>
                        <?php
                        $cont = 0;
                        if ($fs_profesores) {
                            foreach ($fs_profesores as $profesor) {
                                ?>
                                <tr data-id="<?= $profesor["profesor_id"]; ?>"
                                    data-facultad="<?= $profesor["facultad_id"]; ?>"
                                    id="id<?= $profesor["profesor_id"]; ?>">
                                    <td class="text-center font-weight-bold">
                                        <?= $profesor["profesor_clave"]; ?>
                                    </td>
                                    <td class="text-primary">
                                        <?= $profesor["profesor_grado"] . " " . $profesor["profesor_nombre"]; ?>
                                    </td>
                                    <?php if ($user->admin) { ?>
                                        <td class="text-primary">
                                            <?= $profesor["facultad_nombre"]; ?>
                                        </td>
                                    <?php } ?>
                                    <?php if ($user->acceso == 'w') { ?>
                                        <td class="text-center icono-acciones">
                                            <a href="#" data-toggle="modal" data-target="#modal" data-tipo="2" title="Editar"><span
                                                    class="ing-editar ing-fw"></span></a>
                                        </td>
                                    <?php } ?>
                                </tr>
                                <?php
                            }
                        } ?>
                    </tbody>
                </table>
            </div>
        </div>
    </main>
    <!-- Footer -->
    <?php
    include "import/html_footer.php";
    ?>
    <!-- Modal -->
    <div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="modal" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="col-12 modal-tile text-center">
                        <span id="modalLabel">
                            Editar datos de Profesor
                        </span>
                        <button type="button" class="close text-white" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </h4>
                </div>
                <div class="modal-body">
                    <form action="" method="post" id="formaModal" onsubmit="return valida_campos()">
                        <input type="hidden" name="id" id="id">
                        <input type="hidden" name="mfacultad" id="mfacultad">
                        <div class="form-box">
                            <div class="form-group row">
                                <label for="mclave" class="col-4 col-form-label">Clave *</label>
                                <div class="col-8">
                                    <input id="mclave" name="mclave" type="text" class="form-control" maxlength="6" disabled>
                                    <div class="invalid-feedback" id="mclave-error">
                                        Campo obligatorio
                                    </div>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="grado" class="col-4 col-form-label">Grado</label>
                                <div class="col-8">
                                    <input id="grado" name="grado" type="text" class="form-control" maxlength="10">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="desc" class="col-4 col-form-label">Nombre *</label>
                                <div class="col-8">
                                    <input id="nombre" name="nombre" type="text" class="form-control" maxlength="100" disabled>
                                    <div class="invalid-feedback">
                                        Campo obligatorio
                                    </div>
                                </div>
                            </div>
                            <?php if ($user->admin) { ?>
                                <div class="form-group row" id="mdatalist">
                                    <label for="dlfacultad" class="col-4 col-form-label">Facultad *</label>
                                    <div class="col-8">
                                        <div class="datalist datalist-select mb-1 w-100">
                                            <div class="datalist-input">Mostrar todas</div>
                                            <span class="ing-buscar icono"></span>
                                            <ul style="display:none">

                                                <?php foreach ($fs_facultades as $facultad) { ?>
                                                    <li data-id="<?= $facultad['facultad_id']; ?>" class="pl-4"><?= $facultad['facultad_nombre']; ?></li>
                                                <?php } ?>
                                            </ul>
                                            <input type="hidden" id="dlfacultad" name="dlfacultad" value="">
                                        </div>

                                    </div>
                                </div>
                            <?php } ?>
                        </div>
                        <div class="form-group row">
                            <div class="offset-4 col-8">
                                <button type="submit" class="btn btn-outline-primary" id="submitBtn" data-tipo="1">
                                    <span class="ing-aceptar ing-fw"></span> Guardar
                                </button>
                                <button type="reset" class="btn btn-outline-danger" data-dismiss="modal">
                                    <span class="ing-cancelar ing-fw"></span> Cancelar
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <script src="js/jquery.min.js"></script>
    <script src="js/bootstrap/bootstrap.min.js"></script>
    <script src="js/datalist.js"></script>
    <?php
    require_once 'js/messages.php';
    ?>
    <script>
        $('#modal_confirm').on('show.bs.modal', function (event) {
            var button = $(event.relatedTarget);
            var id = button.parents("tr").data("id");
            var facultad = button.parents("tr").data("facultad");
            $("#id_borrar").val(id);
            $("#facultad_borrar").val(facultad);
        });

        $(".btn-borrar").click(function () {
            var cid = $("#id_borrar").val();
            var fac = $("#facultad_borrar").val();
            $.ajax({
                url: 'action/action_profesores_borra.php',
                type: 'post',
                dataType: 'json',
                data: { id_profesor: cid, id_facultad: fac, estado: false },
                success: function (result) {
                    console.log("hecho");
                    $(".btn-reset").click();
                },
                error: function () { console.log("Error") }
            });
        });

        <?php if (!$fs_profesores) { ?>
            triggerMessage("No se encontraron profesores con estos datos en su facultad", "Error");
        <?php }
        if (isset($_GET['error'])) {
            if ($_GET['error'] == 1) { ?>
                triggerMessage("El profesor ya existe en la facultad", "Error");
            <?php }
            if ($_GET['error'] == 2) { ?>
                triggerMessage("Esta clave ya esta en uso", "Error");
            <?php } ?>
        <?php } ?>

        function valida_campos() {
            var error = false;
            if ($("#mclave").val() == "") {
                $("#mclave").addClass("is-invalid");
                $("#mclave-error").html("Campo obligatorio");
                error = true;
            } else {
                $("#mclave").removeClass("is-invalid");
            }

            if ($("#nombre").val() == "") {
                $("#nombre").addClass("is-invalid");
                error = true;
            } else {
                $("#nombre").removeClass("is-invalid");
            }
            if ($("#dlfacultad").val() == "" && $("#mfacultad").val() == "") {
                invalidDatalist("#dlfacultad", true);
                error = true;
            } else {
                invalidDatalist("#dlfacultad", false);
            }
            if (error) {
                return false;
            } else {
                var btn = $('#submitBtn');
                if (btn.data('tipo') == 2)//update
                    $("#formaModal").prop("action", "./action/action_profesores_update.php");
                else {//insert
                    $("#formaModal").prop("action", "#");
                    //alert("insert");
                }
            }
        }

        $(document).on("click", ".btn-reset", function (event) {
            var forma = $(this).parents("form");
            forma.find("input[type=text]").val("");
            setDatalistFirst("#filter_facultad");
            forma.submit();
        });

        $('#modal').on('show.bs.modal', function (event) {//evento cuando se muestra el modal
            var button = $(event.relatedTarget);
            var tipo = button.data('tipo');
            var modal = $(this);
            setDatalistFirst("#dlfacultad");
            if (tipo == 1) {//crear
                $("#mdatalist").show();
                $("#submitBtn").data('tipo', 1);
                $("#modalLabel").html("Crear Profesor");
                $("#mfacultad").val("<?= ($fac); ?>");
                $("#mclave").val("");
                $("#nombre").val("");
                $("#grado").val("");
                $("#id").val("");
            }
            else {//editar
                $("#mdatalist").hide();
                var id = $(event.relatedTarget).parents("tr").data("id");//obtiene el id del registro que llamo al modal
                $("#modalLabel").html("Editar Datos de Profesor");
                $("#submitBtn").data('tipo', 2);
                $.ajax({
                    url: "action/action_profesores_select.php",
                    type: "post",
                    dataType: "json",
                    data: { profesor: id },
                    success: function (result) {
                        $("#mclave").val(result[0]["profesor_clave"]);
                        $("#nombre").val(result[0]["profesor_nombre"]);
                        $("#grado").val(result[0]["profesor_grado"]);

                        $("#id").val(result[0]["profesor_id"]);
                    },
                    error: function () { console.log("Error") }
                });
            }
        });
    </script>
</body>

</html>